/*
*
* Author:              Vadim V. Sinitsyn
* E-mail:              sinvv@asplinux.ru
*
* $Header: /home/cvs/ASPcomplete/linux/include/linux/dq_asp.h,v 1.5 2000/10/07 12:59:27 sinvv Exp $
*
* Remarks:
*
* Last correct: 07/Oct/00
*
*/
#ifndef	_DQ_ASP_H_
#define	_DQ_ASP_H_

#define DQ_ASP_HASH_SIZE		1023

extern int		dq_check_unit(u32 units);
extern int		dq_alloc_unit(u32 units, u32 prealloc);
extern int		dq_alloc_inode(u32 inodes);
extern void		dq_free_unit(u32 units);
extern void		dq_free_inode(u32 inodes);
extern void		dq_sync(u32 force);
extern asmlinkage int	sys_dq_asp(u32 cmd, u32 n, u32 addr1, u32 addr2);
extern asmlinkage int sys_dq_asp_misc(u32 cmd, u32 a, u32 b, u32 c, u32 d);
extern int dq_asp_read_proc(char *page, char **start, off_t off, int count, int *eof, void *data);

extern __inline__ int DQ_PREALLOC_BLOCK(int nr)
{
	if (dq_alloc_unit(nr,1)) return 1;
	return 0;
}

extern __inline__ int DQ_ALLOC_BLOCK(int nr)
{
	if (dq_alloc_unit(nr,0)) return 1;
	return 0;
}

extern __inline__ int DQ_CHECK_BLOCK(int nr)
{
	if (dq_check_unit(nr)) return 1;
	return 0;
}

extern __inline__ int DQ_ALLOC_INODE(void)
{
	if (dq_alloc_inode(1)) return 1;
	return 0;
}

extern __inline__ void DQ_FREE_BLOCK(int nr)
{
	dq_free_unit(nr);
}

extern __inline__ void DQ_FREE_INODE(void)
{
	dq_free_inode(1);
}

#endif  // _DQ_ASP_H_


