#ifndef _LINUX_UBHASH_H
#define _LINUX_UBHASH_H

#ifdef __KERNEL__

#include <linux/beancounter.h>

#define UB_HASH_SIZE 256
#define ub_hash_fun(x) ( ( ((x) >> 8) ^ (x) ) & (UB_HASH_SIZE - 1) )

struct ub_hash_slot {
	spinlock_t ubh_lock;
	struct user_beancounter *ubh_beans;
} ub_hash[UB_HASH_SIZE];

#define lock_beancounters(slot, flags) \
	spin_lock_irqsave(&slot->ubh_lock, flags)

#define unlock_beancounters(slot, flags) \
	spin_unlock_irqrestore(&slot->ubh_lock, flags)

#endif /* __KERNEL__ */
#endif /* _LINUX_UBHASH_H */
