/*
*
* Author:              Vadim V. Sinitsyn
* E-mail:              sinvv@asplinux.ru
*
* $Header: /home/cvs/ASPcomplete/utils/dq.h,v 1.6 2000/10/17 17:08:10 sinvv Exp $
*
* Remarks:
*
* Last correct: 17/Oct/00
*
*/
#ifndef	_DQ_H_
#define	_DQ_H_

#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <getopt.h>
#include <unistd.h>
#include <asm/types.h>
#include <linux/dq_asp_def.h>

extern char *optarg;
extern int	optind, opterr, optopt;

#define ASP_MAIL                "sinvv@asplinux.ru"
#define DQ_ASP_VE_ROOT          "/ve_private/"

#define DQ_ASP_VEID		0
#define DQ_ASP_UID		1
#define DQ_ASP_GID		2
#define DQ_ASP_GLOBAL	0x80

#define DQ_ASP_MIN      60                  // Seconds
#define DQ_ASP_HOUR     60*DQ_ASP_MIN
#define DQ_ASP_DAY      24*DQ_ASP_HOUR
#define DQ_ASP_WEEK     7*DQ_ASP_DAY
#define DQ_ASP_MONTH    30*DQ_ASP_DAY
#define DQ_ASP_YEAR     365*DQ_ASP_DAY

#define DQ_ASP_OK           0       
#define DQ_ASP_BADIN        1       // Bad input params
#define DQ_ASP_BADFORMAT    2       // Bad format

#define BLOCK_SIZE			512

// File primitives
#define dq_lock(fd,lock,type,start,len)				\
		(lock)->l_type		= (type);				\
		(lock)->l_start		= (start);				\
		(lock)->l_len		= (len);				\
		(lock)->l_whence	= 0;					\
		fcntl((fd), F_SETLKW, (lock));

#define _DQ_ASP_ROUND_UP(x,n)						(((x)+(n)-1u) & ~((n)-1u))
#define DQ_ASP_ROUND_UP(x)							_DQ_ASP_ROUND_UP(x,4096)
		
#define dq_readlock(fd,lock,start,len)			dq_lock(fd,lock,F_RDLCK,start,len)

#define dq_writelock(fd,lock,start,len)			dq_lock(fd,lock,F_WRLCK,start,len)

#define dq_unlock(fd,lock,start,len)			dq_lock(fd,lock,F_UNLCK,start,len)

#define dq_create(fd, path)							\
			fd = open(path, O_TRUNC | O_CREAT | O_WRONLY, S_IRUSR | S_IWUSR); \
			if (-1 == fd) {								\
				dprint("Can't create file %s (%s,%d)\n",path,__FILE__,__LINE__);	\
				return EIO;					\
			}

#define dq_open(fd, flags, path)						\
			fd = open(path, flags);						\
			if (-1 == fd) {								\
				dprint("Can't open file %s (%s,%d)\n",path,__FILE__,__LINE__);	\
				return EIO;						\
			}

#define dq_fopen(fp, flags, path)						\
			fp = fopen(path, flags);					\
			if (NULL == fp) {							\
				dprint("Can't open file %s (%s,%d)\n",path,__FILE__,__LINE__);	\
				return EIO;						\
			}

#define dq_close(fd, path)								\
			if (0 != close(fd)) {						\
				dprint("Can't close file %s (%s,%d)\n",path,__FILE__,__LINE__);	\
				return EIO;						\
			}

#define dq_fclose(fp, path)							\
			if (0 != fclose(fp)) {						\
				dprint("Can't close file %s (%s,%d)\n",path,__FILE__,__LINE__);	\
				return EIO;						\
			}

#define dq_seek(fd, offset, path)						\
			if (-1 == lseek(fd, offset, SEEK_SET)) {	\
				dprint("Can't seek in file %s (%s,%d)\n",path,__FILE__,__LINE__); \
				return EIO;						\
			}

#define dq_read(fd, buf, cnt, path)					\
			if (cnt != read(fd, (void *)buf, cnt)) {	\
				dprint("Can't read from file %s (%s,%d)\n",path,__FILE__,__LINE__);	\
				close(fd);								\
				return EIO;						\
			}

#define dq_write(fd, buf, cnt, path)					\
			if (cnt != write(fd, (void *)buf, cnt)) {	\
				dprint("Can't write to file %s (%s,%d)\n",path,__FILE__,__LINE__);	\
				close(fd);								\
				return EIO;						\
			}

// Memory primitives

#define dq_malloc(ptr,size)							\
			if (0 == ((void *)ptr = malloc(size))) {			\
				dprint("Can't allocate %d bytes memory (%s,%d)\n",size,__FILE__,__LINE__); \
				return ENOMEM;						\
			}

#define dq_free(ptr)					free(ptr)

// Sys primitives

#define my_veid			env_create(0, 0, 0)				// Get current veid

#define check_root		if (ROOT_UID != getuid()) {					\
							dprint("The user is not superuser!\n"); \
							return EACCES;					\
						}						
#undef DQ_ASP_SET_DQ_BLK
#define DQ_ASP_SET_DQ_BLK(dq,id,type)  \
            memset((dq), 0, sizeof(dq_blk));                \
            if (DQ_ASP_IS_VEID(type)) {                     \
                (dq)->veid = (dq)->luid = id;               \
            }                                               \
            else {                                          \
			    (dq)->veid	= (dq)->luid = my_veid;	        \
                if (DQ_ASP_IS_UID(type)) (dq)->uid = id;        \
                else if (DQ_ASP_IS_GID(type)) (dq)->gid = id;   \
            }                                               \
            (dq)->flags = type;

#define DQ_ASP_IS   if (dq_ask()) { \
                    printf("Need build kernel with ASP Disk Quota, mail to: %s\n",ASP_MAIL); \
                    return 1;   \
                }


#endif  /* _DQ_H_ */
