/*
*
* Author:              Vadim V. Sinitsyn
* E-mail:              sinvv@asplinux.ru
*
* $Header: /home/cvs/ASPcomplete/utils/dqlib.h,v 1.7 2000/10/17 17:08:10 sinvv Exp $
*
* Remarks:
*
* Last correct: 17/Oct/00
*
*/
#ifndef	_DQLIB_H_
#define	_DQLIB_H_

#include <stdio.h>
#include <ctype.h>
#include "dq.h"

extern int		is_emptyline(in char *buf);
extern void		print_dqblk_header(void);
extern void		print_dqblk(in struct dq_blk *dq, in __u32 format, in __u32 unit_out_format);
extern void		print_getopt_result(in char ret);
extern int		file_exist(in const char *fpath, in int uid, in __u32 access);
extern int		check_magic(in const char *dqb_path);
extern int		read_dqb_cnt(in const char *dqb_path, out __u32 *cnt);
extern int		write_dqb_cnt(in const char *dqb_path, in __u32 cnt);
extern int		create_empty_dqb(in const char *dqb_path);
extern int		validate_dqblk(in struct dq_blk *dq);
extern void		free_list(in struct ldq_blk *dq);
extern void		print_list(in struct ldq_blk *dq);
extern __u32	calc_flags(in __u32 flag);
extern int		is_ve0(void);
extern int		read_dqb(in const char *dqb_path, out struct dq_blk **dq, out __u32 *cnt, out __u32 *ver);
extern int		find_quotas_table(in struct dq_blk	*dq, in __u32 cnt, in struct dq_blk *q, out struct dq_blk **r);
extern int		same_quotas(in struct dq_blk	*q, in struct dq_blk	*p);
extern int		quota_set(out struct dq_blk *dest, in struct dq_blk *src);
extern int		flush_tbl2dqb(in const char *dqb_path, in struct dq_blk *dq, in __u32 cnt);
extern int		dir_size(in const char *fpath, in __u32 type, in __u32 id, in __u32 rec, out __u32 *units, out __u32 *inodes);
extern void		dq_print_stat(in struct dq_stat *stat);
extern void		dq_sync_u(void);
extern int		get_fstype(in char *fpath, out long *fstype);
extern int      dq_ask(void);
extern int      str_isdigit(char *s);
extern int      dq_str2time(char *s, long int *n);
extern int      dq_time2str(long int n, char *s, int format);
extern int      dq_str2unit(char *s, long int *n);
extern int      dq_unit2str(long int n, char *s, int format);
extern int      dq_put(struct dq_blk *dq, const char *dqb_path, int offset);
extern int      dq_put_index(struct dq_blk *dq, const char *dqb_path, int index);

// Syscall
extern int      env_create(unsigned envid, unsigned flags, unsigned addr);
extern int      dq_asp(unsigned cmd, unsigned addr1, unsigned addr2, unsigned n);
extern int      dq_asp_misc(unsigned cmd, unsigned a, unsigned b, unsigned c, unsigned d);

#endif  // _DQLIB_H_
